% -*- coding: utf-8 -*-
%
%
% Calculation of histograms and basic parameters of the combination of several
% random variables
%
% Cálculo de histogramas y parámetros básicos de la combinación de varias
% variables aleatorias
%
%--------------------------------------------------------------------------
%
% LABORATORIO DE TEORÍA DE LA COMUNICACIÓN
%
%        Versión: 1.0
%  Realizado por: Marcelino Lázaro
%                 Departamento de Teoría de la Señal y Comunicaciones
%                 Universidad Carlos III de Madrid
%      Creación : febrero 2023
% Actualización : febrero 2023
%
%--------------------------------------------------------------------------

Nvariables = [1,2,5,10];
Nrealizaciones = 1e4;

% Loop for each value of the number N of variables
% Bucle para cada valor del número N de variables
for k = 1:length(Nvariables)
    % Se generan las realizaciones de las N variables
    N = Nvariables(k);
    x = 1.0 + randn(N,Nrealizaciones);

    % The mean and variance of these realizations are calculated
    % Se calcula la media y la varianza de las realizaciones
    xM = mean(x,1);
    medX = mean(xM);
    varX = var(xM);

    % The average of the N realizations is drawn
    % Se dibuja el promedio de las N realizaciones
    figure(1),subplot(2,2,k)
    plot(xM), axis([1,Nrealizaciones,-4,5])
    title(['Mean = ',num2str(medX),' Variance = ',num2str(varX)])
    xlabel(['Mean of ',num2str(N),' variables'])
    
    % Se dibuja el histograma del promedio de las N realizaciones
    % The histogram of the average of the N realizations is drawn  
    figure(2),subplot(2,2,k)
    hist(xM,50),axis([-4,5,0,Nrealizaciones/10])
    title(['Mean = ',num2str(medX),' Variance = ',num2str(varX)])
    xlabel(['Average of ',num2str(N),' variables'])
end
